Attribute VB_Name = "SoundModule"
Option Explicit
Dim Dx7 As New DirectX7
Dim Ds7 As DirectSound
Const sNumber = 5
Dim Ds7Buffer(1 To sNumber) As DirectSoundBuffer
Public SoundExist As Boolean

Public Static Sub SoundIni()
Dim bufferDesc As DSBUFFERDESC, waveFormat As WAVEFORMATEX, sFile As String, n As Integer
  SoundExist = False
  On Local Error Resume Next
  Set Ds7 = Dx7.DirectSoundCreate("")
  If Err.Number <> 0 Then Exit Sub
  Ds7.SetCooperativeLevel frmMain.hWnd, DSSCL_NORMAL

  bufferDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC

  waveFormat.nFormatTag = WAVE_FORMAT_PCM
  waveFormat.nChannels = 1
  waveFormat.lSamplesPerSec = 22050
  waveFormat.nBitsPerSample = 16
  waveFormat.nBlockAlign = waveFormat.nBitsPerSample / 8 * waveFormat.nChannels
  waveFormat.lAvgBytesPerSec = waveFormat.lSamplesPerSec * waveFormat.nBlockAlign
    
  For n = 1 To sNumber
    sFile = App.Path & "\s" & Chr$(n + 48) & ".wav"
    Set Ds7Buffer(n) = Ds7.CreateSoundBufferFromFile(sFile, bufferDesc, waveFormat)
    If Err.Number <> 0 Then Exit Sub
    Ds7Buffer(n).SetPan 0
  Next n
  SoundExist = True
End Sub

Public Static Sub SetVol(d As Integer)
Dim n As Integer
  For n = 1 To sNumber
    Ds7Buffer(n).SetVolume -(((10 - d) ^ 2) \ 10) * 1000
  Next n
End Sub

Public Static Sub PlaySound(n As Integer)
  If Not SoundExist Then Exit Sub
  If n < 1 Or n > sNumber Then Exit Sub
  Ds7Buffer(n).Play 0
End Sub
